'''''''''''''''''''''''''''''''''''''''''''''''
'           _   _______ _____ __  __ ______ _______ ______ _____    _____       _______       _      ____   _____  _____ ______ _____  
'     /\   | | |__   __|_   _|  \/  |  ____|__   __|  ____|  __ \  |  __ \   /\|__   __|/\   | |    / __ \ / ____|/ ____|  ____|  __ \ 
'    /  \  | |    | |    | | | \  / | |__     | |  | |__  | |__) | | |  | | /  \  | |  /  \  | |   | |  | | |  __| |  __| |__  | |__) |
'   / /\ \ | |    | |    | | | |\/| |  __|    | |  |  __| |  _  /  | |  | |/ /\ \ | | / /\ \ | |   | |  | | | |_ | | |_ |  __| |  _  / 
'  / ____ \| |____| |   _| |_| |  | | |____   | |  | |____| | \ \  | |__| / ____ \| |/ ____ \| |___| |__| | |__| | |__| | |____| | \ \ 
' /_/    \_\______|_|  |_____|_|  |_|______|  |_|  |______|_|  \_\ |_____/_/    \_\_/_/    \_\______\____/ \_____|\_____|______|_|  \_\
'   
'   
'   
'      _  ___  _   _   ____   _____        ____  __    _    _   _ 
'     | |/ _ \| \ | | / ___| / _ \ \      / /  \/  |  / \  | \ | |
'  _  | | | | |  \| | \___ \| | | \ \ /\ / /| |\/| | / _ \ |  \| |
' | |_| | |_| | |\  |  ___) | |_| |\ V  V / | |  | |/ ___ \| |\  |
'  \___/ \___/|_| \_| |____/ \___/  \_/\_/  |_|  |_/_/   \_\_| \_|
'                                                                
'   
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''   

' FOR A 28X1 PICAXE
#picaxe28x1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SYMBOLS AND DEFINITIONS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
symbol serinpin = 5
symbol button1 = input1          ' read/log mode
symbol button2 = input0          ' selma/plaintext read
'''''''''''''''''''
symbol statusled = 0             ' red
symbol statusled2 = 1            ' green
'''''''''''''''''''
symbol log_addr = %10100000      ' default logging address
symbol flight_addr = %10100010   ' address for flight readings
'''''''''''''''''''
symbol testbyte = $55            ' byte to use for connection testing
symbol socbyte = "L"
symbol eocbyte = "E"
symbol intbyte = "R"
'''''''''''''''''''
symbol baud = N1200              ' serial-over-RF baud rate   (use N)
symbol res = 1024
'''''''''''''''''''
symbol selma_start_row = 3
'''''''''''''''''''



'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''
'  ___ _   _ ___ _____ ___    _    _     ___ ____  _____ 
' |_ _| \ | |_ _|_   _|_ _|  / \  | |   |_ _/ ___|| ____|
'  | ||  \| || |  | |  | |  / _ \ | |    | |\___ \|  _|  
'  | || |\  || |  | |  | | / ___ \| |___ | | ___) | |___ 
' |___|_| \_|___| |_| |___/_/   \_\_____|___|____/|_____|
'
'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''
                                                       


init:     ' CHECK FOR READBACK MODE

high statusled2
high statusled
pause 1000
if button1 = 1 then
	let w1 = 0
	gosub setupi2c
	low statusled2
	low statusled
	if button2 = 1 then     ' check for selma mode
		gosub setselmaheaders
		let w2 = selma_start_row   ' selma start row
		goto transmitdata_selma
	endif
	sertxd("+-+-+-+-+-+-+-+-+-+-+-+-+-+",CR,LF,"BEGIN LOG",CR,LF)
	goto transmitdata
endif
low statusled2
low statusled
	

'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''
'  ____  _____ ____ ___ _______     _______ ____  
' |  _ \| ____/ ___|_ _| ____\ \   / / ____|  _ \ 
' | |_) |  _|| |    | ||  _|  \ \ / /|  _| | |_) |
' |  _ <| |__| |___ | || |___  \ V / | |___|  _ < 
' |_| \_\_____\____|___|_____|  \_/  |_____|_| \_\
'
'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''                                                                                  


main:
	'''''''''''''''''''''''''
	serin serinpin, baud, b0
	'''''''''''''''''''''''''
	if b0 = testbyte then connok
	if b0 = socbyte then
		let w1 = 0
		gosub setupi2c
		goto logdata
	endif
	if b0 = intbyte then
		goto initflightdata
	endif
goto main




'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''
'  _     ___   ____   ____    _  _____  _    
' | |   / _ \ / ___| |  _ \  / \|_   _|/ \   
' | |  | | | | |  _  | | | |/ _ \ | | / _ \  
' | |__| |_| | |_| | | |_| / ___ \| |/ ___ \ 
' |_____\___/ \____| |____/_/   \_\_/_/   \_\
'                                           
'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''


logdata:
	high statusled2
	serin [1000,powerfailure], serinpin, baud, b0,b1
	if b0 = eocbyte and b1 = eocbyte then logfinished     ' check for EOC byte
	if b0 = testbyte then powerfailure    ' if the byte is the test byte here, it means the TX reset
	if w0 > res then
		high statusled
		goto logdata    ' if bigger than RESOLUTION then skip
	endif
	low statusled
	hi2cout [log_addr], w1, (b0, b1)
	pause 10     '-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!-!
	w1 = w1 + 2
	if w1 >= 32760 then eepromfull  ' getting too near end of eeprom, so die
goto logdata




logfinished:
w1 = w1 + 1
hi2cout [log_addr], w1, (0,0,0)   ' write a few 0s
low statusled2
finished_loop:
high statusled
pause 100
low statusled
pause 500
goto finished_loop

'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''
'  _____ ____      _    _   _ ____  __  __ ___ _____   ___ _   _ _____ _____ ____  _   _    _    _     
' |_   _|  _ \    / \  | \ | / ___||  \/  |_ _|_   _| |_ _| \ | |_   _| ____|  _ \| \ | |  / \  | |    
'   | | | |_) |  / _ \ |  \| \___ \| |\/| || |  | |    | ||  \| | | | |  _| | |_) |  \| | / _ \ | |    
'   | | |  _ <  / ___ \| |\  |___) | |  | || |  | |    | || |\  | | | | |___|  _ <| |\  |/ ___ \| |___ 
'   |_| |_| \_\/_/   \_\_| \_|____/|_|  |_|___| |_|   |___|_| \_| |_| |_____|_| \_\_| \_/_/   \_\_____|
'
'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''

initflightdata:
	high statusled2
	gosub setupi2c
	serin serinpin, baud, b0,b1
							'sertxd(#w0,CR,LF) '!!!!!!!!!!!!!!!!!
	hi2cout [flight_addr], 0 , (b0, b1)
	serin serinpin, baud, b0,b1
							'sertxd(#w0,CR,LF) '!!!!!!!!!!!!!!!!!
	hi2cout [flight_addr], 2 , (b0, b1)
	pause 20                            ' page write buffer
	let w2 = 4   ' reset write cursor
goto downloadflightdata




downloadflightdata:
serin serinpin, baud, b0,b1
					'sertxd(#w0,CR,LF)
if b0 = eocbyte and b1 = eocbyte then
	hi2cout [flight_addr], w2 , (0,0,0)     ' write a few 0s
	pause 20  ' write buffer
	low statusled2
	goto finished_loop
endif
'sertxd(#w0,CR,LF)
hi2cout [flight_addr], w2 , (b0, b1)
pause 20     ' write buffer
w2 = w2 + 2
goto downloadflightdata




'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''
'  _______  ______   ___  ____ _____ 
' | ____\ \/ /  _ \ / _ \|  _ \_   _|
' |  _|  \  /| |_) | | | | |_) || |  
' | |___ /  \|  __/| |_| |  _ < | |  
' |_____/_/\_\_|    \___/|_| \_\|_| 
'
'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''


' PLAIN TEXT MODE


transmitdata:
	high statusled2
	hi2cin [log_addr], w1, (b0, b1)
	if w0 = 0 then
		sertxd("END LOG",CR,LF,"+-+-+-+-+-+-+-+-+-+-+-+-+-+",CR,LF,"BEGIN INTERNAL LOG",CR,LF)
		let w1 = 0   ' reset read cursor
		goto transmitinternal
	endif
	sertxd(#w0,CR,LF)     ' send data out via sertxd
	w1 = w1 + 2
goto transmitdata




transmitinternal:
	hi2cin [flight_addr], w1, (b0, b1)
	if w0 = 0 then
		sertxd("END INTERNAL LOG",CR,LF,"+-+-+-+-+-+-+-+-+-+-+-+-+-+")
		low statusled2
		goto finished_loop
	endif
	if w1 = 0 then
		sertxd("Zero: ")
	endif
	if w1 = 2 then
		sertxd("Peak: ")
	endif
	sertxd(#w0,CR,LF)
	w1 = w1 + 2
goto transmitinternal



'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''


' SELMADAQ MODE


transmitdata_selma:
	high statusled2
	hi2cin [log_addr], w1, (b0, b1)
	if w0 = 0 then
		let w1 = 0   ' reset read cursor
		let w2 = selma_start_row
		goto transmitinternal_selma
	endif
	sertxd("CELL,SET,C",#w2,",",#w0,CR,LF)     ' send data out via sertxd
	w1 = w1 + 2
	w2 = w2 + 1   ' move selma cell cursor
goto transmitdata_selma



transmitinternal_selma:
	hi2cin [flight_addr], w1, (b0, b1)
	if w0 = 0 then
		sertxd("MSG, Download Complete",CR,LF)
		low statusled2
		high statusled
		pause 200
		low statusled
		goto main
	endif
	sertxd("CELL,SET,B",#w2,",",#w0,CR,LF)
	w1 = w1 + 2
	w2 = w2 + 1   ' move selma cell cursor
goto transmitinternal_selma



setselmaheaders:
	sertxd("MSG, Downloading Flight Data",CR,LF)
	sertxd("LABEL, -, Local, Remote",CR,LF)
	sertxd("CELL,SET,A3,Zero",CR,LF)
	sertxd("CELL,SET,A4,Peak",CR,LF)
return




'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''
'  ____  _   _ ____ ____  
' / ___|| | | | __ ) ___| 
' \___ \| | | |  _ \___ \ 
'  ___) | |_| | |_) |__) |
' |____/ \___/|____/____/ 
'
'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''

' GENERAL SUBROUTINES AND WORKER FUNCTIONS

setupi2c:
	hi2csetup i2cmaster, log_addr, i2cfast, i2cword
return


timeout:
high statusled
low statusled2
pause 50
high statusled2
low statusled
pause 50
goto timeout


powerfailure:
w1 = w1 + 1          ; write 0s so that data is useable after power fail
hi2cout [log_addr], w1, (0,0,0)   ' write a few 0s
pause 20
high statusled
low statusled2
pause 250
high statusled2
low statusled
pause 250
goto powerfailure


connok:
	high statusled
	pause 20
	low statusled
goto main




die:
low statusled2
high statusled
pause 10000
goto die



eepromfull:
	low statusled2
	high statusled
	pause 100
	low statusled
	pause 100
goto eepromfull




'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''
'  _____ _   _ ____  
' | ____| \ | |  _ \ 
' |  _| |  \| | | | |
' | |___| |\  | |_| |
' |_____|_| \_|____/ 
'                                    
'''''''''''''''''''''''''''''''''''''''''''''''
'''''''''''''''''''''''''''''''''''''''''''''''

